<?php

namespace Lumav\EveryPay\Api;

/**
 * Interface for managing quote payment information
 * @api
 */
interface PaymentInformationAdapterInterface
{
    /**
     * @param string $cartId
     * @param int $tokenId
     * @param string $methodId
     * @param \Magento\Quote\Api\Data\PaymentInterface $paymentMethod
     * @param \Magento\Quote\Api\Data\AddressInterface|null $billingAddress
     * @return string
     */
    public function adaptPlaceOrder(
        $cartId,
        $tokenId,
        $methodId,
        \Magento\Quote\Api\Data\PaymentInterface $paymentMethod,
        \Magento\Quote\Api\Data\AddressInterface $billingAddress = null
    );
}
