<?php

namespace Lumav\EveryPay\Block;

class Landing extends \Magento\Framework\View\Element\Template
{
	/**
	 * @var \Magento\Framework\Registry
	 */
	protected $registry;

	/**
	 * @var string
	 */
	protected $orderReference;

	/**
	 * @param \Magento\Framework\View\Element\Template\Context $context
	 * @param \Magento\Framework\Registry $registry
	 * @param array $data
	 */
	public function __construct(
		\Magento\Framework\View\Element\Template\Context $context,
		\Magento\Framework\Registry $registry,
		array $data = []
	) {
		$this->registry = $registry;
		parent::__construct($context, $data);
	}

	/**
	 * @return string
	 */
	public function getSuccessMessage()
	{
		return __('Payment successful. Redirecting to success page.');
	}

	/**
	 * @return string
	 */
	public function getFailureMessage()
	{
		return __('Payment unsuccessful. Redirecting to failure page.');
	}

	/**
	 * @return string
	 */
	public function getWaitingMessage()
	{
		return __('Please wait while we check your payment status...');
	}

	/**
	 * @return string|null
	 */
	public function getOrderReference()
	{
		if (!$this->orderReference) {
			if ($reference = $this->registry->registry('order_reference')) {
				$this->registry->unregister('order_reference');
				$this->orderReference = $reference;
			}
		}
		return $this->orderReference;
	}

	/**
	 * @return string
	 */
	public function getAjaxRequestUrl()
	{
		return $this->getUrl('everypay/customer/payment');
	}

	/**
	 * @var return string
	 */
	public function getSuccessUrl()
	{
		return $this->getUrl('checkout/onepage/success');
	}

	/**
	 * @return string
	 */
	public function getFailureUrl()
	{
		return $this->getUrl('checkout/onepage/failure');
	}
}