<?php

namespace Lumav\EveryPay\Block;

class PaymentForm extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Lumav\EveryPay\Model\Config
     */
    protected $config;

    /**
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Lumav\EveryPay\Model\Config $config
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Lumav\EveryPay\Model\Config $config,
        array $data = []
    ) {
        $this->config = $config;

        parent::__construct($context, $data);
    }

    /**
     * @return \Magento\Framework\View\Element\Template
     */
    protected function _prepareLayout()
    {
        $this->addChild(
            'iframe',
            'Lumav\EveryPay\Block\IFrame',
            ['template' => 'Lumav_EveryPay::iframe.phtml']
        );

        $this->addChild(
            'redirect-form',
            'Lumav\EveryPay\Block\RedirectForm',
            ['template' => 'Lumav_EveryPay::redirect-form.phtml']
        );
        
        $this->addChild(
            'apple',
            'Lumav\EveryPay\Block\Apple',
            ['template' => 'Lumav_EveryPay::apple.phtml']
        );
        
        $this->addChild(
            'google',
            'Lumav\EveryPay\Block\Google',
            ['template' => 'Lumav_EveryPay::google.phtml']
        );

        return parent::_prepareLayout();
    }

    /**
     * @return bool
     */
    public function isIFrame()
    {
        return $this->config->getFormType() ===  \Lumav\EveryPay\Model\Adminhtml\Source\FormType::FORM_TYPE_IFRAME;
    }

    /**
     * @return bool
     */
    public function isApplePayAvailable()
    {
        return $this->config->isApplePayAvailable();
    }

    /**
     * @return bool
     */
    public function isGooglePayAvailable()
    {
        return $this->config->isGooglePayAvailable();
    }
}