<?php
declare(strict_types=1);

namespace Lumav\EveryPay\Block\System\Config\Form\Field;

class MethodLabelColumn extends \Magento\Framework\View\Element\AbstractBlock
{
    /**
     * Set "name" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputName($value)
    {
        return $this->setName($value);
    }

    /**
     * Set "id" for <select> element
     *
     * @param $value
     * @return $this
     */
    public function setInputId($value)
    {
        return $this->setId($value);
    }

    /**
     * Render HTML
     *
     * @return string
     *
     * @SuppressWarnings(PHPMD.CyclomaticComplexity)
     * @SuppressWarnings(PHPMD.NPathComplexity)
     */
    protected function _toHtml()
    {
        if (!$this->_beforeToHtml()) {
            return '';
        }

        $html = '<input id="' . $this->getId() . '" type="hidden" name="' . $this->getName() . '" value="1"/>' .
            '<label class="' . $this->getClass() .
                '" title="' . $this->escapeHtml($this->getTitle()) . '" ' .
                $this->getExtraParams() . '>' . 
            $this->escapeHtml('<%- ' . $this->getColumnName() . ' %>') . '</label>';

        return $html;
    }
}