<?php

namespace Lumav\EveryPay\Block\System\Config\Form\Field;

use Lumav\EveryPay\Block\System\Config\Form\Field\MethodLabelColumn;
use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;

class MethodsOrder extends AbstractFieldArray
{
    /**
     * @var string
     */
    protected $_template = 'Lumav_EveryPay::system/config/form/field/array.phtml';
    
    /**
     * @var MethodLabelColumn
     */
    private $methodLabelColumn;

    /**
     * Prepare rendering the new field by adding all the needed columns
     */
    protected function _prepareToRender()
    {
        $this->addColumn('label', [
            'label' => __('Method'),
            'renderer' => $this->getLabelRenderer()
        ]);

        $this->_addAfter = false;
    }

    /**
     * Prepare existing row data object.
     *
     * @param \Magento\Framework\DataObject $row
     * @return void
     */
    protected function _prepareArrayRow(\Magento\Framework\DataObject $row)
    {
        $options = [];

        $row->setData('option_extra_attrs', $options);
    }

    /**
     * @return MethodLabelColumn
     * @throws LocalizedException
     */
    private function getLabelRenderer()
    {
        if (!$this->methodLabelColumn) {
            $this->methodLabelColumn = $this->getLayout()->createBlock(
                MethodLabelColumn::class,
                '',
                ['data' => ['is_render_to_js_template' => true]]
            );
        }
        return $this->methodLabelColumn;
    }
}