<?php

namespace Lumav\EveryPay\Controller\Adminhtml\Methods;

use Magento\Framework\Exception\LocalizedException;

class Update extends \Magento\Backend\App\Action
{
    /**
     * @var \Lumav\EveryPay\Model\Gateway
     */
    protected $api;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Lumav\EveryPay\Model\Gateway $api
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Lumav\EveryPay\Model\Gateway $api
    ) {
        $this->api = $api;
        parent::__construct($context);
    }

    /**
     * Updates payment methods
     *
     * @return \Magento\Framework\View\Result\PageFactory
     */
    public function execute()
    {
        try{
            $this->api->updatePaymentMethods();        
        } catch (LocalizedException $e) {
            $this->getResponse()->setHttpResponseCode(204);
        }
    }
}