<?php

namespace Lumav\EveryPay\Controller\Customer;

use Magento\Framework\Controller\ResultFactory;

/**
 * Class Payment
 */
class Payment extends \Magento\Framework\App\Action\Action
{
    /**
     * @var \Lumav\EveryPay\Helper\Validator
     */
    protected $validator;

    /**
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Lumav\EveryPay\Helper\Validator $validator
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Lumav\EveryPay\Helper\Validator $validator
    ) {
        $this->validator = $validator;
        parent::__construct($context);
    }

    /**
     * {@inheritDoc}
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            $reference = $this->getRequest()->getParam('order_reference');
            $result = $this->validator->isOrderPaid($reference);
            
            $resultJson = $this->resultFactory->create(ResultFactory::TYPE_JSON);
            
            if (is_array($result)) {
                foreach ($result as $err) {
                    $this->logger->info(__($err));
                }
                $resultJson->setData(['result' => false, 'isError' => true]);
                return $resultJson;
            }
            
            $resultJson->setData(['result' => (bool) $result]);
            return $resultJson;
        }
    }
}