<?php

namespace Lumav\EveryPay\Controller\Payment;

use Magento\Framework\Controller\ResultFactory;

/**
 * Class Status
 */
class Status extends \Magento\Framework\App\Action\Action
{
    /**
     * @var \Lumav\EveryPay\Model\Gateway
     */
    protected $api;

    /**
     * @var \Lumav\EveryPay\Logger\Logger
     */
    protected $logger;

    /**
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Lumav\EveryPay\Model\Gateway $api
     * @param \Lumav\EveryPay\Logger\Logger $logger
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Lumav\EveryPay\Model\Gateway $api,
        \Lumav\EveryPay\Logger\Logger $logger
    ) {
        $this->api = $api;
        $this->logger = $logger;
        parent::__construct($context);
    }

    /**
     * {@inheritDoc}
     */
    public function execute()
    {
        $result = $this->resultFactory->create(ResultFactory::TYPE_JSON);
        $params = [];
        $content = parse_str($this->getRequest()->getContent(), $params);
        if(empty($params)) {
            $params = $this->getRequest()->getParams();
        }
        $paymentRef = isset($params['payment_reference']) ? $params['payment_reference'] : null;
        $orderRef = isset($params['order_reference']) ? $params['order_reference'] : null;
        $this->logger->info(sprintf(
            __('Received request to update payment status. Payment reference: %s, order reference: %s'),
            $paymentRef,
            $orderRef
        ));

        if ($paymentRef) {
            if ($this->api->updatePaymentStatus($paymentRef)) {
                $result->setHttpResponseCode(200);
                return $result;
            }
        }
        $result->setHttpResponseCode(403);
        return $result;
    }
}