<?php

namespace Lumav\EveryPay\Helper;

class ResponseProcessor
{
    /**
     * @var \Lumav\EveryPay\Model\Token\TokenManagement
     */
    protected $tokenManager;

    /**
     * @var OrderProcessor
     */
    protected $orderProcessor;

    /**
     * @param \Lumav\EveryPay\Model\Token\TokenManagement $tokenManager
     * @param OrderProcessor $orderProcessor
     */
    public function __construct(
        \Lumav\EveryPay\Model\Token\TokenManagement $tokenManager,
        OrderProcessor $orderProcessor
    ) {
        $this->tokenManager = $tokenManager;
        $this->orderProcessor = $orderProcessor;
    }

    /**
     * @param array $data
     * @return $this
     */
    public function process($data)
    {
        $this->tokenManager->saveToken($data);
        $this->orderProcessor->process($data);

        return $this;
    }
}