<?php

namespace Lumav\EveryPay\Model\Adminhtml\Source;

use Magento\Framework\Option\ArrayInterface;
use Lumav\EveryPay\Model\Config;

class DefaultCountry implements ArrayInterface
{
    /**
     * @var Config
     */
    protected $config;

    /**
     * @var \Magento\Directory\Model\Config\Source\Country
     */
    protected $countryList;

    /**
     * @param Config $config
     */
    public function __construct(
        Config $config,
        \Magento\Directory\Model\Config\Source\Country $countryList
    ) {
        $this->config = $config;
        $this->countryList = $countryList;
    }

    /**
     * Possible environment types
     *
     * @return array
     */
    public function toOptionArray()
    {
        $options = [];

        $codes = $this->config->getSupportedCountries();
        foreach ($this->countryList->toOptionArray() as $countryData) {
            if (isset($countryData['value']) && in_array($countryData['value'], $codes)) {
                $options[] = $countryData;
            }
        }

        return $options;
    }
}
