define([
    'jquery',
    'jquery/ui'
], function ($) {
    'use strict';

    var widgetButtonsFix = {
        /**
         * Init buttons.
         * Select movable item based on items option and don't restrict only on one nesting level.
         */
         initButtons: function () {
            this.element.find('input.up').on('click', $.proxy(function (event) {
                $('body').trigger(this.options.moveUpEvent, {
                    item: $(event.target).parents(this.options.items).first()
                });
            }, this));
            this.element.find('input.down').on('click', $.proxy(function (event) {
                $('body').trigger(this.options.moveDownEvent, {
                    item: $(event.target).parents(this.options.items).first()
                });
            }, this));
        }
    };

    return function (targetWidget) {

        $.widget('mage.sortable', targetWidget, widgetButtonsFix);

        return $.mage.sortable;
    };
});