define(
    [
        'jquery',
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/model/url-builder',
        'Magento_Customer/js/model/customer',
        'mage/storage',
        'Magento_Checkout/js/model/place-order',
        'Magento_Checkout/js/model/error-processor',
        'Magento_Checkout/js/model/full-screen-loader'
    ],
    function ($, quote, urlBuilder, customer, storage, placeOrderService, errorProcessor, fullScreenLoader) {
        'use strict';

        return function (paymentData, messageContainer) {
            var serviceUrl, payload;

            var agreementForm = $('.payment-method._active form[data-role=checkout-agreements]'),
                agreementData = agreementForm.serializeArray(),
                agreementIds = [];

            if (agreementData.length == 0) {
                agreementForm = $('.payment-method._active div[data-role=checkout-agreements] input');
                agreementData = agreementForm.serializeArray();
            }

            agreementData.forEach(function(item) {
                agreementIds.push(item.value);
            });

            if (paymentData['extension_attributes'] === undefined) {
                paymentData['extension_attributes'] = {};
            }

            paymentData['extension_attributes']['agreement_ids'] = agreementIds;


            payload = {
                cartId: quote.getQuoteId(),
                methodId: 'google',
                billingAddress: quote.billingAddress(),
                paymentMethod: paymentData
            };

            if (customer.isLoggedIn()) {
                serviceUrl = urlBuilder.createUrl('/everypay/payment-adapter/mine', {});
                payload.tokenId = 0;
            } else {
                serviceUrl = urlBuilder.createUrl('/everypay/payment-adapter/:quoteId', {
                    quoteId: quote.getQuoteId()
                });
                payload.email = quote.guestEmail;
            }

            var returnValue = false;
            var oneoff = $.ajax({
                url: BASE_URL + serviceUrl,
                contentType: "application/json",
                data: JSON.stringify(payload),
                method: "POST",
                async: false,
                success : function(response) {
                    returnValue = response;
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) { 
                    errorProcessor.process(errorThrown, messageContainer);
                }
            });
            
            return returnValue;
        };
    }
);
