define(
    ['ko'], function (ko) {
        'use strict';
        function Method(code, name, logoUrl, methodType, country, visible = true)
        {
            this.code = code;
            this.name = name;
            this.logoUrl = logoUrl;
            this.methodType = methodType;
            this.country = country;
            this.visible = ko.observable(visible);
            
            this.getId = function() {
                return this.code;
            };
            this.getName = function() {
                return this.name;
            };
            this.getImgUrl = function() {
                return this.logoUrl;
            };
            this.getType = function() {
                return this.methodType;
            };
            this.getCountry = function() {
                return this.country;
            };
            this.isVisible = function() {
                return this.visible();
            };
            this.setVisibility = function(visible) {
                this.visible(visible);
            }
        }

        Method.prototype.fromData = function (data) {
            var paymentMethods = [];
            Object.keys(data).map(function(type) {
                if (Array.isArray(data[type])) {
                    paymentMethods.push.apply(paymentMethods, data[type].map(function(method) {
                        return new Method(
                            method.source,
                            method.display_name,
                            method.logo_url,
                            type,
                            method.country_code
                        );
                    }));
                }
            });
            return paymentMethods;
        };
        Method.prototype.newFromInstance = function (method) {
            return new Method(method.code, method.name, method.logoUrl, method.methodType, method.country);
        };

        return Method;
    }
);
